@echo off
REM ############################################################
REM ## Copyright (c) 2007-2010 - OpenSmartHome.com - WOSH
REM ## All rights reserved.
REM ##  open source, founded by Alessandro Polo
REM ##  http://www.OpenSmartHome.com
REM ##  http://www.AlessandroPolo.name
REM ############################################################
REM ## This script (re)builds WOSH and its components
REM ## using Microsoft Visual Studio 2005-2008 (8.0,9.0)
REM ############################################################
REM #                                              CONFIGURATION

set ROOT=..

REM G:\dev\Qt\2010.01\bin\qtenv.bat

if "%QTDIR_WIN32%"=="" (
	echo Setting DEFAULT option of QTDIR_WIN32 = G:\dev\Qt\win32.4.6.1
	set QTDIR_WIN32=G:\dev\Qt\win32.4.6.1
)

if "%QTDIR_WINCE%"=="" (
REM	echo Setting DEFAULT option of QTDIR_WINCE = G:\dev\Qt\win32.4.6.1
	set QTDIR_WINCE=G:\dev\Qt\wince.4.6.1
)


:config
REM ############################################################

if not "%VSINSTALLDIR%"=="" goto devenv

if not "%VS80COMNTOOLS%"=="" call "%VS80COMNTOOLS%vsvars32.bat"
if not "%VS90COMNTOOLS%"=="" call "%VS90COMNTOOLS%vsvars32.bat"

REM ############################################################
:devenv

if exist "%VS80COMNTOOLS%..\IDE\VCExpress.*" set DEVENV="%VS80COMNTOOLS%..\IDE\VCExpress"
if exist "%VS90COMNTOOLS%..\IDE\VCExpress.*" set DEVENV="%VS90COMNTOOLS%..\IDE\VCExpress"

if exist "%VS80COMNTOOLS%..\IDE\devenv.*" set DEVENV="%VS80COMNTOOLS%..\IDE\devenv"
if exist "%VS90COMNTOOLS%..\IDE\devenv.*" set DEVENV="%VS90COMNTOOLS%..\IDE\devenv"

set DEVENV_OPT=/nologo /rebuild Debug
REM #    /clean

REM #                                              CONFIGURATION
REM ############################################################
:bootscript

cd %ROOT%

set TARGET=%1
if "%TARGET%"=="" goto menu

set OPTION=%2
if "%OPTION%"=="" goto menu2

:selection
if "%TARGET%"=="all" goto all
if "%TARGET%"=="lib" goto lib
if "%TARGET%"=="woshsrv" goto woshsrv
if "%TARGET%"=="woshshop" goto woshshop
if "%TARGET%"=="woshremote" goto woshremote
if "%TARGET%"=="woshkiosk" goto woshkiosk
if "%TARGET%"=="woshcesrv" goto woshcesrv
if "%TARGET%"=="3rdparty" goto 3rdparty
if "%TARGET%"=="msi" goto msi
if "%TARGET%"=="copydll" goto copydll
goto noparam

REM ############################################################
REM ############################################################
REM #                                                        ALL
:all
echo Building ALL..
echo.

REM #                                                        ALL
REM ############################################################
REM #                                                   3RDPARTY
:3rdparty
echo Building WOSH 3rd-party libraries.. [\lib\3rdparty]
echo.
echo  Building GAlib.. [\lib\3rdparty\galib\ga.vcproj]
cd lib\3rdparty
%DEVENV% /nologo /build Debug galib\ga.vcproj
cd ..\..
if not "%TARGET%"=="all" goto end
REM #                                                   3RDPARTY
REM ############################################################
REM #                                                    WOSHSRV
:woshsrv
echo Building WOSH Server.. [\src\apps\woshsrv]
set PATH=%QTDIR_WIN32%\bin;%PATH%
echo  Creating project.. [\src\woshsrv.pro]
cd src
%QTDIR_WIN32%\bin\qmake woshsrv.pro -t vcapp
cd ..
echo.
if not "%OPTION%"=="nopause" pause
if not "%OPTION%"=="qmake-only" (
	echo.
	echo  Building solution.. [\src\woshsrv.vcproj]
	cd src
	%DEVENV% %DEVENV_OPT% woshsrv.vcproj
	cd ..
 )
if not "%TARGET%"=="all" goto end
REM #                                                    WOSHSRV
REM ############################################################
REM #                                                   WOSHSHOP
:woshshop
echo Building WOSH WorkShop.. [\src\apps\woshshop]
set PATH=%QTDIR_WIN32%\bin;%PATH%
echo  Creating project.. [\src\woshshop.pro]
cd src
%QTDIR_WIN32%\bin\qmake woshshop.pro -t vcapp
cd ..
echo.
if not "%OPTION%"=="nopause" pause
if not "%OPTION%"=="qmake-only" (
	echo.
	echo  Building solution.. [\src\woshshop.vcproj]
	cd src
	%DEVENV% %DEVENV_OPT% woshshop.vcproj
	cd ..
 )
if not "%TARGET%"=="all" goto end
REM #                                                   WOSHSHOP
REM ############################################################
REM #                                                 WOSHREMOTE
:woshremote
echo Building WOSH Remote.. [\src\apps\woshremote]
set PATH=%QTDIR_WIN32%\bin;%PATH%
echo  Creating project.. [\src\woshremote.pro]
cd src
%QTDIR_WIN32%\bin\qmake woshremote.pro -t vcapp
cd ..
echo.
if not "%OPTION%"=="nopause" pause
if not "%OPTION%"=="qmake-only" (
	echo.
	echo  Building solution.. [\src\woshremote.vcproj]
	cd src
	%DEVENV% %DEVENV_OPT% woshremote.vcproj
	cd ..
 )
if not "%TARGET%"=="all" goto end
REM #                                                 WOSHREMOTE
REM ############################################################
REM #                                                        MSI
:msi
echo Building WOSH Installer package (msi).. [\build\msi-package\WoshInstaller.vdproj]
echo.
goto copydll
:msi2
echo.
echo  Creating MSI package..
%DEVENV% %DEVENV_OPT% build\msi-package\WoshInstaller.vdproj
if not "%TARGET%"=="all" goto end
REM #                                                        MSI
REM ############################################################
REM ############################################################
REM #                                               REQUIRED DLL
:copydll
echo Copying QT DLL(s) (such as %QTDIR_WIN32%\lib\QtCore4.dll)
echo.
REM ## release DLL
copy %QTDIR_WIN32%\lib\QtCore4.dll bin\ > NUL
copy %QTDIR_WIN32%\lib\QtNetwork4.dll bin\ > NUL
copy %QTDIR_WIN32%\lib\QtXml4.dll bin\ > NUL
copy %QTDIR_WIN32%\lib\QtSql4.dll bin\ > NUL
copy %QTDIR_WIN32%\lib\QtGui4.dll bin\ > NUL
copy %QTDIR_WIN32%\lib\phonon4.dll bin\ > NUL
REM ## debug DLL
copy %QTDIR_WIN32%\lib\QtCored4.dll bin\ > NUL
copy %QTDIR_WIN32%\lib\QtNetworkd4.dll bin\ > NUL
copy %QTDIR_WIN32%\lib\QtXmld4.dll bin\ > NUL
copy %QTDIR_WIN32%\lib\QtSqld4.dll bin\ > NUL
copy %QTDIR_WIN32%\lib\QtGuid4.dll bin\ > NUL
copy %QTDIR_WIN32%\lib\phonond4.dll bin\ > NUL
if "%TARGET%"=="msi" goto msi2
if "%TARGET%"=="copydll" goto end
REM #                                               REQUIRED DLL
REM ############################################################

goto end

REM ############################################################
REM #                                                  WOSHKIOSK
:woshkiosk
echo Building WOSH Remote.. [\src\apps\woshkiosk]
set PATH=%QTDIR_WIN32%\bin;%PATH%
echo  Creating project.. [\src\woshkiosk.pro]
cd src
%QTDIR_WIN32%\bin\qmake woshkiosk.pro -t vcapp
cd ..
echo.
if not "%OPTION%"=="nopause" pause
if not "%OPTION%"=="qmake-only" (
	echo.
	echo  Building solution.. [\src\woshkiosk.vcproj]
	cd src
	%DEVENV% %DEVENV_OPT% woshkiosk.vcproj
	cd ..
 )
if not "%TARGET%"=="all" goto end
REM #                                                  WOSHKIOSK
REM ############################################################
REM #                                                    WOSHLIB
:lib
echo Building WOSH (as) Library..
set PATH=%QTDIR_WIN32%\bin;%PATH%
echo  Creating project.. [\src\woshlib.pro]
cd src
%QTDIR_WIN32%\bin\qmake woshlib.pro -t vclib
cd ..
echo.
if not "%OPTION%"=="nopause" pause
if not "%OPTION%"=="qmake-only" (
	echo.
	echo  Building solution.. [\src\libwosh.vcproj]
	cd src
	%DEVENV% %DEVENV_OPT% libwosh.vcproj
	cd ..
 )
if not "%TARGET%"=="all" goto end
REM #                                                    WOSHLIB
REM ############################################################
REM #                                                  WOSHTOOLS
:tools
set PATH=%QTDIR_WIN32%\bin;%PATH%
cd src\tools


cd ..\..
if not "%TARGET%"=="all" goto end
REM #                                                  WOSHTOOLS
REM ############################################################
REM #                                                  WOSHCESRV
:woshcesrv
echo Building WOSH CE Server.. [\src\woshcesrv.vcproj]
echo  Configuring environment.. [wincewm60standard-msvc2008]
REM set PATH=%QTDIR_WINCE%\bin;%PATH%
call %QTDIR_WINCE%\bin\setcepaths.bat wincewm60standard-msvc2008
if not "%OPTION%"=="nopause" pause
echo  Creating project.. [\src\woshcesrv.pro]
cd src
%QTDIR_WINCE%\bin\qmake woshcesrv.pro -t vcapp
cd ..
echo.
if not "%OPTION%"=="nopause" pause
if not "%OPTION%"=="qmake-only" (
	echo.
	echo  Building solution.. [\src\woshcesrv.vcproj]
	cd src
	%DEVENV% %DEVENV_OPT% woshcesrv.vcproj
	cd ..
	if not "%OPTION%"=="nopause" pause
	echo.
	echo  Copying QT DLL(s) (such as %QTDIR_WINCE%\lib\QtCore4.dll)
	echo.
	REM ## release DLL
	copy %QTDIR_WINCE%\lib\QtCore4.dll bin\woshcesrv\ > NUL
	copy %QTDIR_WINCE%\lib\QtNetwork4.dll bin\woshcesrv\ > NUL
	copy %QTDIR_WINCE%\lib\QtXml4.dll bin\woshcesrv\ > NUL
	REM ## debug DLL
	copy %QTDIR_WINCE%\lib\QtCored4.dll bin\woshcesrv\ > NUL
	copy %QTDIR_WINCE%\lib\QtNetworkd4.dll bin\woshcesrv\ > NUL
	copy %QTDIR_WINCE%\lib\QtXmld4.dll bin\woshcesrv\ > NUL
 )
if not "%TARGET%"=="all" goto end
REM #                                                  WOSHCESRV
REM ############################################################
REM ############################################################
REM #                                                      CLEAN



REM #                                                      CLEAN
REM ############################################################

goto end

REM ############################################################
REM #                                                  QT SELECT
:select_qtwin32
echo PATH of QT for Win32 (%QTDIR_WIN32%) is invalid!
echo.

if not exist "%QTDIR_WINCE%" goto config
:select_qtwince
echo PATH of QT for WinCE (%QTDIR_WINCE%) is invalid!
echo.

goto end
REM #                                                  QT SELECT
REM ############################################################
REM #                                                       MENU
:menu
echo Choose Building TARGET: {all,woshsrv,woshshop,woshremote,woshkiosk,woshcesrv,lib,3rdparty,msi}
echo.
:choice
SET /P TARGET=[all,woshsrv,woshshop,woshremote,woshkiosk,woshcesrv,lib,3rdparty,msi]?
if "%OPTION%"=="" goto menu2
goto selection
REM ############################################################
:menu2
echo Choose Building OPTION: {qmake-only,nopause,none}
echo.
:choice2
SET /P OPTION=[qmake-only,nopause,none]?
goto selection
REM ############################################################
:noparam
echo.
echo ERROR: Missing or invalid TARGET.
echo.
echo  Usage:
echo   make_msvc.bat TARGET {all,woshsrv,woshshop,woshremote,woshkiosk,woshcesrv,lib,3rdparty,msi} OPTION(s)
echo.
if not "%OPTION%"=="nopause" pause
exit 1
REM ############################################################
:end
echo.
echo All Done.
pause
echo.
