@echo off
REM ############################################################
REM ## Copyright (c) 2007-2010 - OpenSmartHome.com - WOSH
REM ## All rights reserved.
REM ##  open source, founded by Alessandro Polo
REM ##  http://www.OpenSmartHome.com
REM ##  http://www.AlessandroPolo.name
REM ############################################################
REM ## This script (re)builds WOSH Applications
REM ## Requirements:
REM ##  - Microsoft Visual Studio 2005-2008 (8.0,9.0)
REM ##  - QT 4.4 (or later) built (locally) for Windows
REM ##    Define 'QTDIR_WIN32' in your environment settings.
REM ############################################################
REM #                                              CONFIGURATION

set ROOT=..

if "%QTDIR_WIN32%"=="" (
	echo Setting DEFAULT option of QTDIR_WIN32 = G:\dev\Qt\win32.4.6.1
	set QTDIR_WIN32=G:\dev\Qt\win32.4.6.1
)


:config
REM ############################################################

if exist "%QTDIR_WIN32%\bin\qtenv.bat" call "%QTDIR_WIN32%\bin\qtenv.bat" 

if not "%VSINSTALLDIR%"=="" goto devenv

if not "%VS80COMNTOOLS%"=="" call "%VS80COMNTOOLS%vsvars32.bat"
if not "%VS90COMNTOOLS%"=="" call "%VS90COMNTOOLS%vsvars32.bat"

REM ############################################################
:devenv

if exist "%VS80COMNTOOLS%..\IDE\VCExpress.*" set DEVENV="%VS80COMNTOOLS%..\IDE\VCExpress"
if exist "%VS90COMNTOOLS%..\IDE\VCExpress.*" set DEVENV="%VS90COMNTOOLS%..\IDE\VCExpress"

if exist "%VS80COMNTOOLS%..\IDE\devenv.*" set DEVENV="%VS80COMNTOOLS%..\IDE\devenv"
if exist "%VS90COMNTOOLS%..\IDE\devenv.*" set DEVENV="%VS90COMNTOOLS%..\IDE\devenv"

set DEVENV_OPT=/nologo /rebuild Debug
REM #    /clean

REM #                                              CONFIGURATION
REM ############################################################
:bootscript

cd %ROOT%

REM ############################################################
echo.
echo WOSH Framework 2010
echo ===================
REM ############################################################

set OPTION=%1
if "%OPTION%"=="" goto menu

REM ############################################################
:selection
REM ############################################################
echo.
echo WOSH Framework 2010
echo ===================
echo Building WOSH 3rd-party libraries.. [\lib\3rdparty]
echo.
REM ############################################################
REM #                                                    WOSHSRV
:lib
echo Building WOSH (as) Library..
set PATH=%QTDIR_WIN32%\bin;%PATH%
echo  Creating project.. [\src\woshlib.pro]
cd src
%QTDIR_WIN32%\bin\qmake woshlib.pro -t vclib
cd ..
echo.
if not "%OPTION%"=="nopause" pause
if not "%OPTION%"=="qmake-only" (
	echo.
	echo  Building solution.. [\src\libwosh.vcproj]
	cd src
	%DEVENV% %DEVENV_OPT% libwosh.vcproj
	cd ..
 )
if not "%TARGET%"=="all" goto end
REM #                                                    WOSHSRV
REM ############################################################

goto end

REM ############################################################
REM #                                                  QT SELECT
:select_qtwin32
echo PATH of QT for Win32 (%QTDIR_WIN32%) is invalid!
echo.
goto end
REM #                                                  QT SELECT
REM ############################################################
REM #                                                       MENU
:menu
echo  Choose Building OPTION:
:choice
SET /P OPTION=[qmake-only,none]?
goto selection
REM ############################################################
:end
echo.
echo All Done.
pause
echo.
