/**
 * @file    releasenotes.h
 * @brief   Documentation: Release notes of WOSH Framework
 ****************************************************************************
 * @author  Alessandro Polo
 * @version 0.8.499 $Id: releasenotes.h 2251 2010-03-29 08:32:31Z alex $
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

/*! \page page_releasenotes Release Notes
 *
 *
 * \htmlonly <hr/> \endhtmlonly
 ****************************************************************************
 * \section page_releasenotes_news NEWS
 *
 * Notes of current release, simpler and shorter than ChangeLog, end-users' audience.
 *
 * Refer to file <a href="../../NEWS">/NEWS</a> (prompt here).
 * \include ./NEWS
 *
 *
 * \htmlonly <hr/> \endhtmlonly
 ****************************************************************************
 * \section page_releasenotes_changelog ChangeLog
 *
 * ChangeLog of WOSH distributions, developers' audience.
 *
 * Refer to file <a href="../../ChangeLog">/ChangeLog</a>.
 *
 *
 * \htmlonly <hr/> \endhtmlonly
 ****************************************************************************
 * \section page_releasenotes_svn WOSH trunk (SVN) Log
 *
 * You may browse the log online:
 *  - <a href="https://code.launchpad.net/wosh">LaunchPad Branches</a>
 *  - <a href="http://wosh.svn.sourceforge.net/viewvc/wosh/">SourceForge SVN browser</a>
 *
 * You may see latest commits' log executing:
 * \verbatim
alex@linbox:/$ svn log https://wosh.svn.sourceforge.net/svnroot/wosh
\endverbatim
 *
 *
 * \htmlonly <hr/> \endhtmlonly
 ****************************************************************************
 * \section page_releasenotes_roadmap RoadMap
 *
 * Plans about future development
 *
 * Refer to file <a href="../../RoadMap">/RoadMap</a> (prompt here).
 * \include ./RoadMap
 *
 *
 ****************************************************************************
 *
 */ 
