/**
 * @class   FormConfigurationPages
 * @brief   
 *
 * @version $Id: FormConfigurationPages.h 1708 2010-01-26 22:28:01Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Apps_WoshTrayServer_FormConfigurationPages_H__
 #define __WOSH_Apps_WoshTrayServer_FormConfigurationPages_H__

#include "FormConfigurationPage.h"


class ConfigurationPage : public FormConfigurationPage  {

	public:
		ConfigurationPage(QWidget *parent = 0);
		virtual ~ConfigurationPage() { }

	public:

		virtual WRESULT reset();

		virtual WRESULT apply();
		virtual WRESULT discard();

	protected:

		QStringList findQmFiles();

		QComboBox* cmbTranslations;
};


class QueryPage : public FormConfigurationPage  {
	public:
		QueryPage(QWidget *parent = 0);
		virtual ~QueryPage() { }

	public:

		virtual WRESULT reset();

		virtual WRESULT apply();
		virtual WRESULT discard();

};


class UpdatePage : public FormConfigurationPage  {
	public:
		UpdatePage(QWidget *parent = 0);
		virtual ~UpdatePage() { }

	public:

		virtual WRESULT reset();

		virtual WRESULT apply();
		virtual WRESULT discard();

};


#endif //__WOSH_Apps_WoshTrayServer_FormConfigurationPages_H__
