/**
 * @class   wosh::application::FormScreenshoter
 * @brief   Graphic tool showing messages on a Bus
 *          
 *          
 *
 ****************************************************************************
 * @version $Id: FormScreenshoter.h 2193 2010-03-23 06:46:47Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Apps_WoshShop_FormScreenshoter_H__
 #define __WOSH_Apps_WoshShop_FormScreenshoter_H__

 #include <woshDefs.h>
 #include <QtGui/QWidget>
 #include <QPixmap>


using namespace wosh;
namespace Ui {
 class FormScreenshoter;
};
namespace wosh {
 namespace application {


class FormScreenshoter : public QWidget
 {
	Q_OBJECT

	public:
		FormScreenshoter(QWidget *parent = 0);
		virtual ~FormScreenshoter();

	protected slots:
		void btnTakeShot_clicked();
		void btnSave_clicked();
		void btnSaveTo_clicked();

		void shootScreen();

	protected:
		void changeEvent(QEvent* e);
		void keyPressEvent(QKeyEvent* event);
		void resizeEvent(QResizeEvent* event);
		void updatePreview();

		QString getCurrentFileName() const;

	protected:
		QPixmap originalPixmap;
		WId selectedWidgetId;
		QString quickSaveLastPath;

	private:
		Ui::FormScreenshoter *m_ui;

}; // class def

 }; // namespace application
}; // namespace wosh


#endif // __WOSH_Apps_WoshShop_FormScreenshoter_H__
