/** @file    Mail.cpp
 *  @author  Alessandro Polo
 *  @version $Id: Mail.cpp 1708 2010-01-26 22:28:01Z alex $
 *  @brief
 * File containing methods for the wosh::Mail class.
 * The header for this class can be found in Mail.h, check that file
 * for class description.
 ****************************************************************************/
/* Copyright (c) 2009, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/
 
 #include "Mail.h"

 #include <QDateTime>


using namespace std;
namespace wosh {

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////// CONSTRUCTORS

Mail::Mail( int Id )
 {
	clear();
	
	this->id = Id;
 }

Mail::~Mail()
 {
 }

//////////////////////////////////////////////////////////////////////////////////////////////// CONSTRUCTORS
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////// CONFIGURATION

void Mail::clear()
 {
	//this->id = 0;

	this->uid = "";
	this->read = false;

	this->headers.clear();
	this->sender_name = "";
	this->sender_add = "";
	this->destination_mail = "";
	this->subject = "";
	this->body = "";

	this->size = 0;
	this->timestamp = 0;
	this->attachments = NULL;
 }

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////


WRESULT Mail::loadFromPlain( const string& data )
 {
	WRESULT ret = WRET_OK;

	size_t pos = data.find("\r\n\r\n");

	ret = parseHeaders( data.substr(0, pos) );
	
	this->body = data.substr(pos+1);

	return WRET_OK;
 }

 

WRESULT Mail::parseHeaders( const string& pop3_headers )
 {
	this->headers.clear();
/*
	int hpos = 0;
	QStringList sl = QString::fromStdString(pop3_headers).split("\r\n",QString::SkipEmptyParts);
	for (int i=1;i<sl.count();i++) {
		hpos = sl[i].indexOf(": ");
		if ( hpos <= 0 )
			continue;
		this->headers[ sl[i].left(hpos).toStdString() ] = sl[i].mid(hpos+2).toStdString();
	 }

	this->destination_mail = this->headers["To"];
	this->subject = this->headers["Subject"];

	///@bug parse sender
	QString sender = QString::fromStdString(this->headers["From"]);
	this->sender_name = "";
	this->sender_add = this->headers["From"];
	int lpos = sender.lastIndexOf(">");
	if ( lpos > 0 ) {
		sender = sender.left(lpos);
		int rpos = sender.lastIndexOf("<");
		if ( rpos > 0 ) {
			this->sender_name = sender.left(rpos).toStdString();
			this->sender_add = sender.mid(rpos+1).toStdString();
		}
	 }

	// parse date, format: Tue, 1 Aug 2006 10:30:34 +0300
	QString mts = QString::fromStdString(this->headers["Date"]);
	int comma = 0;// Delete weekday
	if ( ( comma = mts.indexOf( ',' ) ) != -1 )
		mts.remove( 0, comma + 1 );

	// Delete timezone as all after time
	int post = mts.lastIndexOf( ':' );
	post = mts.indexOf( ' ', post );
	if ( -1 != post )
		mts.remove( post, mts.size() - post );
	mts = mts.trimmed();
//	QByteArray dateText( mts.data(), mts.size() );

	time_t emailDate = QDateTime::fromString( mts, "d MMM yyyy hh:mm:ss" ).toTime_t();
	this->timestamp = emailDate;

*/
	return WRET_OK;
 }



//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////


};
