# QMAKE Configuration file
# Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
# by Alessandro Polo - OpenSmartHome.com
# All rights reserved.
#######################################################
# Revision $Id: MailBox.pro 1708 2010-01-26 22:28:01Z alex $
#######################################################

CONFIG += console rtti stl exceptions thread moc
QT -= gui

DEPENDPATH += .
INCLUDEPATH += . ../../../

OBJECTS_DIR = ../../../../tmp/MailBox

INCLUDEPATH += /usr/include
LIBS += -L/usr/lib
LIBS += -lgloox

HEADERS += MailBoxImpl.h
SOURCES += MailBoxImpl.cpp

HEADERS += IMailBoxListener.h

HEADERS += MailBoxBundle.h
SOURCES += MailBoxBundle.cpp

HEADERS += 3rdparty/SendEmail.h
SOURCES += 3rdparty/SendEmail.cpp

########################################################################
# custom building setting (will override)
!include( ../services.pri ) {
	message( "*****  No custom build options specified. *****" )
	message( "*****  Building Bundles - Services - MailBox TEST *****" )
	#CONFIG += make_app_test
} 

#CONFIG += make_lib_static
#CONFIG += make_lib_shared
#CONFIG += make_plugin
#CONFIG += make_app_test
########################################################################


########################################################################
############################################################# LIB STATIC
make_lib_static  {
	message("WOSH Framework - Bundles - Services - MailBox - LIB STATIC")

	TEMPLATE = lib
	CONFIG += staticlib
	TARGET = bundleMailBox
	DESTDIR = ../../../../lib

}
########################################################################
############################################################# LIB SHARED
make_lib_shared {
	message("WOSH Framework - Bundles - Services - MailBox - LIB SHARED")

	TEMPLATE = lib
	TARGET = bundleMailBox
	DESTDIR = ../../../../lib

}
########################################################################
################################################################# PLUGIN
make_plugin {
	message("WOSH Framework - Bundles - Services - MailBox - PLUGIN")

	TEMPLATE = lib
	TARGET = plugin_MailBoxBundle
	DESTDIR = ../../../../bin

	SOURCES += plugin_MailBoxBundle.cpp

}
########################################################################
########################################################################
############################################################### APP TEST
make_app_test {
	message("WOSH Framework - Bundles - Services - MailBox - APP TEST")

	TEMPLATE = app
	TARGET = test_MailBox
	DESTDIR = ../../../../bin

	LIBS += -L../../../../lib
	LIBS += -lcore

	HEADERS -= MailBoxBundle.h
	SOURCES -= MailBoxBundle.cpp

	SOURCES += test_MailBox.cpp

}
########################################################################
