/**
 * @class   GardenerWorker
 * @brief   
 *
 *
 *
 *
 *
 *
 *
 ****************************************************************************
 * @version $Id: GardenerWorker.h 2803 2010-07-26 14:28:07Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Service_Gardener_Impl_H__
 #define __WOSH_Service_Gardener_Impl_H__

 #include <core/BundleGenericWorker.h>

 #include "GardenerProgram.h"

using namespace wosh;
namespace wosh {
 namespace xtended {
  class WeatherInfo;
  };
 };

class GardenerWorker;

class IGardenerListener {
	public:

	public:
		virtual ~IGardenerListener() { }
};

typedef MapT<std::string,GardenerProgram*> tStrGardenerProgramMap;


class GardenerWorker : public BundleGenericWorker
 {

	public:
		/**
		 * @brief   Default constructor. Init vars.
		 * @param bundle [in] the parent bundle, see BundleGenericWorker interface
		 */
		GardenerWorker( BundleGeneric& bundle );
		/**
		 * @brief   Deconstructor. If thread is stll running, it will be stopped.
		 */
		virtual ~GardenerWorker();


	public:
		WRESULT addProgram( GardenerProgram* program );

		WRESULT controlProgram( const std::string& target_program, bool activate, bool exclusive = true );

		void evaluateWeatherUpdate( const wosh::xtended::WeatherInfo* updated_info, double similarity = -1.0 );


		void setListener( IGardenerListener* ptr )	{ this->listener = ptr;}


/** @name Setters
 * @{
 ******************************************************************************/
 	public:

//@}
/** @name Getters
 * @{
 ******************************************************************************/
 	public:
		const tStrGardenerProgramMap& getPrograms() const	{ return this->programs; }
		tStrGardenerProgramMap& getPrograms()				{ return this->programs; }

//@}
	protected:
		void runThread();

	protected:
		tStrGardenerProgramMap programs;

		IGardenerListener* listener;


}; // class def

#endif //__WOSH_Service_Gardener_Impl_H__
