/**
 * @class   FreeLingImpl
 * @brief   
 *
 *
 *
 *
 *
 ****************************************************************************
 * @version $Id: FreeLingImpl.h 2323 2010-04-22 13:56:45Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Services_FreeLingImpl_H__
 #define __WOSH_Services_FreeLingImpl_H__

 #include <core/BundleGenericWorker.h>
 #include <core/List.h>

 #include <core/Notification.h>
 #include <framework/communication/TextMessage.h>
 #include <framework/communication/NotificationConversion.h>

 #include <list>
 #include <freeling.h>


using namespace std;
using namespace wosh;
using namespace wosh::communication;

class tokenizer;
class splitter;
class maco_options;
class maco;
class hmm_tagger;
class chart_parser;
class dep_txala;


class FreeLingJob {

	public:
		FreeLingJob() {
			this->conversion = NULL;
		 }
		virtual ~FreeLingJob() { }

	public:
		NotificationConversion* conversion;
		URI requestSource;
};


class FreeLingImpl : public BundleGenericWorker  {

	public:

		/**
		 * @brief   Default constructor. Init vars.
		 * @param bundle [in] the parent bundle, see BundleGenericWorker interface
		 */
		FreeLingImpl( BundleGeneric& bundle );

		/**
		 * @brief   Deconstructor. If thread is stll running, it will be stopped.
		 */
		virtual ~FreeLingImpl();


	public:


		void enqueue( FreeLingJob* job );

		void processJob( FreeLingJob* job );

//@}
/** @name Setters
 * @{
 ******************************************************************************/
	public:


//@}
/** @name Getters
 * @{
 ******************************************************************************/
	public:


//@}
/** @name Internal methods
 * @{
 ******************************************************************************/
	protected:

void processSentences( const list<sentence>& ls );
void analyzeText( const string& text, list<sentence>& processed );
void configure( maco_options* options, const string& path );


		/**
		 * @brief   
		 * @see     running
		 * @see     
		 */
		virtual void runThread();

//@}

		List<FreeLingJob*> jobs;

		tokenizer* flTokenizer;
		splitter* flSplitter;
		maco_options* flMacoOptions;
		maco* flMacoMorfo;
		hmm_tagger* flTagger;
		chart_parser* flParser;
		dep_txala* flTxala;





}; // class def


#endif //__WOSH_Services_FreeLingImpl_H__
