# QMAKE Configuration file
# Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
# by Alessandro Polo - OpenSmartHome.com
# All rights reserved.
#######################################################
# Revision $Id: TelnetServer.pro 1708 2010-01-26 22:28:01Z alex $
#######################################################

CONFIG += console rtti stl exceptions thread moc
QT -= gui

DEPENDPATH += .
INCLUDEPATH += . ../../../

OBJECTS_DIR = ../../../../tmp/TelnetServer

INCLUDEPATH += /usr/include
LIBS += -L/usr/lib
LIBS += -lgloox

HEADERS += TelnetServerImpl.h
SOURCES += TelnetServerImpl.cpp

HEADERS += ITelnetServerListener.h

HEADERS += TelnetServerBundle.h
SOURCES += TelnetServerBundle.cpp


########################################################################
# custom building setting (will override)
!include( ../services.pri ) {
	message( "*****  No custom build options specified. *****" )
	message( "*****  Building Bundles - Services - TelnetServer TEST *****" )
	#CONFIG += make_app_test
} 

#CONFIG += make_lib_static
#CONFIG += make_lib_shared
#CONFIG += make_plugin
#CONFIG += make_app_test
########################################################################


########################################################################
############################################################# LIB STATIC
make_lib_static  {
	message("WOSH Framework - Bundles - Services - TelnetServer - LIB STATIC")

	TEMPLATE = lib
	CONFIG += staticlib
	TARGET = bundleTelnetServer
	DESTDIR = ../../../../lib

}
########################################################################
############################################################# LIB SHARED
make_lib_shared {
	message("WOSH Framework - Bundles - Services - TelnetServer - LIB SHARED")

	TEMPLATE = lib
	TARGET = bundleTelnetServer
	DESTDIR = ../../../../lib

}
########################################################################
################################################################# PLUGIN
make_plugin {
	message("WOSH Framework - Bundles - Services - TelnetServer - PLUGIN")

	TEMPLATE = lib
	TARGET = plugin_TelnetServerBundle
	DESTDIR = ../../../../bin

	SOURCES += plugin_TelnetServerBundle.cpp

}
########################################################################
########################################################################
############################################################### APP TEST
make_app_test {
	message("WOSH Framework - Bundles - Services - TelnetServer - APP TEST")

	TEMPLATE = app
	TARGET = test_TelnetServer
	DESTDIR = ../../../../bin

	LIBS += -L../../../../lib
	LIBS += -lcore

	HEADERS -= TelnetServerBundle.h
	SOURCES -= TelnetServerBundle.cpp

	SOURCES += test_TelnetServer.cpp

}
########################################################################
