/*
Moon Phase Calculator

With this Moon Phase Calculator you can calculate the date and time (maximum +/- 2 mins) of new moon and full moon of any given month of any year. By default it will display the moon phase according to the current PC system time.

contact me:
sourab_bose2002@yahoo.co.in
file submitted at www.planet-source-code.com
*/



#ifndef CALENDAR_H
 #define CALENDAR_H

 #include <ctime>
 #include <cmath>
 #include <string>
 #include <string.h>

using namespace std;

struct calendar 
{
	int yy;
	int mm;
	int dd;
	int hr;
	int min;
	int sec;
};

calendar JDtoCalendar(double jd); //converts julian date to calendar date 
double calendarToJD(calendar cal);//converts calendar to julian date
void calcNewMoonPhase(const calendar cur, calendar &prev,calendar &next);
void calcFullMoonPhase(calendar cur,calendar &prev,calendar &next);
void getCurMoonPhase(calendar &prevN,calendar &nextN ,calendar &prevF, calendar &nextF);
void getThisMoonPhase(int dd,int mm,int yy,calendar &prevN,calendar &nextN ,calendar &prevF, calendar &nextF);

void dDate2TM(calendar& cal, struct tm& time_out);

#endif
