/**
 * @class   WeatherSourceIGoogleAPI
 * @brief   
 *

 ****************************************************************************
 * @version $Id: WeatherSourceIGoogleAPI.h 2804 2010-07-27 04:39:07Z alex $
 * @author Alessandro Polo
 * @date   Released on 2009-06-04
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_SERVICES_WeatherSourceIGoogleAPI_H__
 #define __WOSH_SERVICES_WeatherSourceIGoogleAPI_H__

 #include "WeatherSourceHttp.h"

using namespace wosh;
using namespace wosh::network;

class WeatherSourceIGoogleAPI : public WeatherSourceHttp
 {
	WOSH_CLASSNAME(WeatherSourceIGoogleAPI)

	public:
		WeatherSourceIGoogleAPI();
		virtual ~WeatherSourceIGoogleAPI() { }

	public:
		virtual WRESULT loadForecast( WeatherInfo* wCurrentInfo, std::vector<WeatherInfo*>* forecast );

	protected:
		WRESULT parseWeatherCondition( const std::string& condition_str, int& condition, int& xtra ) const;

	protected:
		std::string city;
		std::string city_postal;

}; // class def


#endif //__WOSH_SERVICES_WeatherSourceIGoogleAPI_H__
