/** @file    utils.cpp
 *  @author  Alessandro Polo
 *  @version $Id: utils.cpp 2335 2010-04-23 21:55:04Z alex $
 *  @brief   multi-platform implementation of generic functions.
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#include "utils.h"

using namespace std;

// http://msdn.microsoft.com/it-it/library/ms235631.aspx

void ConvertToString(const wchar_t* Src, std::string &target)
 {
    size_t origsize = wcslen(Src) + 1;
	size_t chrConverted = 0;
	char* buffer = new char[origsize];
	memset(buffer, 0, origsize );
#ifdef _OS_MINGW
	wcstombs(buffer, Src, origsize);
#else
	wcstombs_s(&chrConverted, buffer, origsize, Src, _TRUNCATE);
#endif
	target.assign( buffer );
	delete [] buffer;
 }


std::string getStdStringFrom( TCHAR* Src )
 {
#ifndef UNICODE
	return std::string(Src);
#else
	std::string dest;
	ConvertToString(Src, dest);
	return dest;
#endif
 }

