/**
 * @class   wosh::gui::WidgetFileSystemBrowser
 * @brief   To be totally reviewed, atually used just to test QDirModel/gui
 *          
 *          
 *
 ****************************************************************************
 * @version $Id: WidgetFileSystemBrowser.h 2184 2010-03-20 13:19:23Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Gui_WidgetFileSystemBrowser_H__
 #define __WOSH_Gui_WidgetFileSystemBrowser_H__

 #include <core/FileSystem.h>

 #include <QtGui/QWidget>
 #include <QtGui/QDirModel>
 #include <QtGui/QTreeView>
 #include <QtGui/QVBoxLayout>


namespace wosh {
 namespace gui {


class WidgetFileSystemBrowser : public QWidget {

	Q_OBJECT

	public:

		WidgetFileSystemBrowser(QWidget *parent = 0) : QWidget(parent)
		 {
			this->dirModel = new QDirModel();

			this->treeView = new QTreeView(this);
			this->treeView->setObjectName(QString::fromUtf8("treeView"));
			this->treeView->setModel(this->dirModel);

			this->treeView->setRootIndex(this->dirModel->index(QDir::currentPath()));

			QVBoxLayout* verticalLayout_2 = new QVBoxLayout(this);
			verticalLayout_2->setObjectName(QString::fromUtf8("verticalLayout_2"));
			verticalLayout_2->addWidget(treeView);
		 }

		virtual ~WidgetFileSystemBrowser()
		 {
			delete this->treeView;
			delete this->dirModel;
		 }

	public:

		virtual void refresh()
		 {
			this->dirModel->refresh();
		 }


	protected:

		QDirModel* dirModel;
		QTreeView* treeView;


}; // class def

 }; // namespace gui
}; // namespace wosh


#endif //__WOSH_Gui_WidgetFileSystemBrowser_H__
