/**
 * @class   wosh::gui::FormLogViewer
 * @brief   
 *          
 *          
 *
 ****************************************************************************
 * @version $Id: FormLogViewer.h 2460 2010-05-12 07:35:30Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef FORMLOGVIEWER_H
#define FORMLOGVIEWER_H

 #include <QtGui/QWidget>
 #include <QtGui/QTextEdit>

 #include <framework/gui/components/LogHandlerQRenderer.h>


namespace Ui {
 class FormLogViewer;
};
namespace wosh {
 namespace gui {


class FormLogViewer : public QWidget {

	Q_OBJECT

	public:
		FormLogViewer(QWidget *parent = 0);
		virtual ~FormLogViewer();

	protected slots:
		void btnFontChange_clicked();
		void btnBackgroundChange_clicked();

	protected:
		void changeEvent(QEvent *e);

		void mapToDefaultHandler( bool enable );

	private:
		Ui::FormLogViewer *m_ui;

		LogHandlerQRenderer* cHandler;

}; // class def

 }; // namespace gui
}; // namespace wosh


#endif // FORMLOGVIEWER_H
