# QMAKE Configuration file
# Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
# by Alessandro Polo - OpenSmartHome.com
# All rights reserved.
#######################################################
# Revision $Id: gui.pro 2643 2010-06-10 23:51:40Z alex $
#######################################################

message( "WOSH - FRAMEWORK [GUI]" )

DEFINES += WOSH_GUI
QT += gui

RESOURCES += framework/gui/gui.qrc


HEADERS += framework/gui/BuildingObjectGraphicsItem.h
SOURCES += framework/gui/BuildingObjectGraphicsItem.cpp

HEADERS += framework/gui/WoshTreeModel.h

HEADERS += framework/gui/FormBundle.h
SOURCES += framework/gui/FormBundle.cpp
FORMS   += framework/gui/FormBundle.ui

HEADERS += framework/gui/FormContainer.h


#######################################################

HEADERS += framework/gui/GuiUtilities.h
SOURCES += framework/gui/GuiUtilities.cpp

#######################################################

HEADERS += framework/gui/IWidget.h
SOURCES += framework/gui/IWidget.cpp

HEADERS += framework/gui/IWidgetSerializable.h

	HEADERS += framework/gui/WidgetFileSystemBrowser.h

HEADERS += framework/gui/WidgetFileSelector.h
FORMS   += framework/gui/WidgetFileSelector.ui

HEADERS += framework/gui/WidgetMediaList.h
FORMS   += framework/gui/WidgetMediaList.ui

HEADERS += framework/gui/WidgetMediaZone.h
FORMS   += framework/gui/WidgetMediaZone.ui

HEADERS += framework/gui/WidgetMethods.h
SOURCES += framework/gui/WidgetMethods.cpp
FORMS   += framework/gui/WidgetMethods.ui

HEADERS += framework/gui/WidgetMethodCaller.h
SOURCES += framework/gui/WidgetMethodCaller.cpp
FORMS   += framework/gui/WidgetMethodCaller.ui

#####

HEADERS += framework/gui/WoshObject.h

HEADERS += framework/gui/WoshObjectTreeModel.h
SOURCES += framework/gui/WoshObjectTreeModel.cpp

HEADERS += framework/gui/WoshTableModel.h
SOURCES += framework/gui/WoshTableModel.cpp


!include( framework/gui/modules/modules.pro ) {
	message( "*****  No framework/gui/modules/modules.pro file found. *****" )
	message( "*****  FAILED *****" )
}

!include( framework/gui/components/components.pro ) {
	message( "*****  No framework/gui/components/components.pro file found. *****" )
	message( "*****  FAILED *****" )
}

!include( framework/gui/dialogs/dialogs.pro ) {
	message( "*****  No framework/gui/dialogs/dialogs.pro file found. *****" )
	message( "*****  FAILED *****" )
}

!include( framework/gui/bundles/bundles.pro ) {
	message( "*****  No framework/gui/bundles/bundles.pro file found. *****" )
	message( "*****  FAILED *****" )
}

!include( framework/gui/widgets/widgets.pro ) {
	message( "*****  No framework/gui/widgets/widgets.pro file found. *****" )
	message( "*****  FAILED *****" )
}

# WOSH_KIOSK {
# 	!include( framework/gui/kiosk/kiosk.pro ) {
# 		message( "*****  No framework/gui/kiosk/kiosk.pro file found. *****" )
# 		message( "*****  FAILED *****" )
# 	}
# }


