/**
 * @class   wosh::gui::wBuilding_BuildingGeometry
 * @brief   Graphical interface of wosh::wosh::building::BuildingGeometry
 *          
 *          
 *
 ****************************************************************************
 * @version $Id: wBuilding_BuildingGeometry.h 2458 2010-05-12 05:22:46Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Gui_Widgets_Building_BuildingGeometry_H__
 #define __WOSH_Gui_Widgets_Building_BuildingGeometry_H__

 #include <framework/gui/IWidgetSerializable.h>
 #include <QtGui/QWidget>
 #include <QAbstractListModel>

 #include <framework/building/BuildingGeometry.h>


namespace Ui {
 class wBuilding_BuildingGeometry;
 class wBuilding_BuildingGeometry_Point3D;
};


namespace wosh {
 namespace gui {

class wBuilding_BuildingGeometry_Point3D :	public QWidget
 {
    Q_OBJECT

	public:
		wBuilding_BuildingGeometry_Point3D(QWidget *parent = 0);
		virtual ~wBuilding_BuildingGeometry_Point3D();

	public slots:
		WRESULT loadObject( const wosh::building::Point3D* point );
		WRESULT saveObject( wosh::building::Point3D* point ) const;

	private:
		Ui::wBuilding_BuildingGeometry_Point3D *m_ui;


 };
	 



class wBuilding_BuildingGeometry :	public QWidget,
									public virtual IWidgetSerializableTA<wosh::building::BuildingGeometry>
 {
    Q_OBJECT

	WOSH_WIDGET_SERIALIZABLE(wosh::gui::wBuilding_BuildingGeometry)

	public:
		wBuilding_BuildingGeometry(QWidget *parent = 0);
		virtual ~wBuilding_BuildingGeometry();

	public slots:
		WRESULT loadObject( const wosh::building::BuildingGeometry* bgeom );
		WRESULT saveObject( wosh::building::BuildingGeometry* bgeom ) const;

	protected:
		void changeEvent(QEvent *e);

	private:
		Ui::wBuilding_BuildingGeometry *m_ui;


}; // class def

// ----------------------------------------------------------------------------------------


 }; // namespace gui
}; // namespace wosh


#endif //__WOSH_Gui_Widgets_Building_BuildingGeometry_H__
