/**
 * @file    wEntertainment.h
 * @brief   
 *          
 *          
 *
 ****************************************************************************
 * @version $Id: wEntertainment.h 2455 2010-05-12 02:46:32Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Gui_Widgets_Entertainment_H__
 #define __WOSH_Gui_Widgets_Entertainment_H__

 #include <framework/gui/IWidgetSerializable.h>
 #include <QtGui/QWidget>

 #include <framework/entertainment/MediaTrack.h>


namespace Ui {
 class wEntertainment_MediaTrack;
};
namespace wosh {
 namespace gui {


// ----------------------------------------------------------------------------------------

class wEntertainment_MediaTrack :	public QWidget,
									public virtual IWidgetSerializableT<wosh::entertainment::MediaTrack>
 {
	Q_OBJECT

	WOSH_WIDGET_SERIALIZABLE(wosh::gui::wEntertainment_MediaTrack)

	public:
		wEntertainment_MediaTrack(QWidget* parent = NULL);
		virtual ~wEntertainment_MediaTrack();

	public:
		WRESULT loadObject( const wosh::entertainment::MediaTrack* object );
		WRESULT saveObject( wosh::entertainment::MediaTrack* object ) const;

	protected:

	signals:
		void updatedObject();

	private:
		Ui::wEntertainment_MediaTrack *m_ui;

}; // class def

// ----------------------------------------------------------------------------------------

// ----------------------------------------------------------------------------------------




 }; // namespace gui
}; // namespace wosh


#endif //__WOSH_Gui_Widgets_Entertainment_H__
