/**
 * @class   wosh::persistence::EncoderProtocolSql
 * @brief   
 *
 ****************************************************************************
 * @version $Id: EncoderProtocolSql.h 2505 2010-05-22 02:03:13Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Persistence_EncoderProtocolSql_H__
 #define __WOSH_Persistence_EncoderProtocolSql_H__

 #include <woshDefs.h>
 #include <core/EncoderProtocol.h>
  #include <core/PersistenceManager.h>
 // #include <core/Serialization.h>
 //#include <core/Containers.h>
 //#include <core/ObjectAllocator.h>


namespace wosh {
 namespace persistence {


class PersistenceDbSql : public PersistenceDb
{
	WOSH_CLASSNAME(wosh::persistence::PersistenceDbSql)
	WOSH_CLASS_ABSTRACT(true)

	public:
		PersistenceDbSql() : PersistenceDb() { }
		virtual ~PersistenceDbSql() { }

	public:
		virtual inline const char* getProtocol() const		{ return "SQL"; }
		virtual inline double getProtocolVersion() const	{ return 0.0; }

}; // class def

// ------------------------------------------------------------------------------------------------------------------------

class EncoderProtocolSql : public EncoderProtocol
 {
	WOSH_CLASSNAME(wosh::persistence::EncoderProtocolSql)
	WOSH_CLASS_ABSTRACT(true)

	public:
		EncoderProtocolSql();
		virtual ~EncoderProtocolSql() { }

	public:
		const char* getProtocol() const		{ return "SQL"; }
		double getProtocolVersion() const	{ return 0.0; }

	public:
	//	 // meyer singleton
	//	static MapT<std::string, ObjectTypeInfo>& getMappings() {
	//		static MapT<std::string, ObjectTypeInfo> mappings;
	//		return mappings;
	//	 }

}; // class def

// ------------------------------------------------------------------------------------------------------------------------

class EncoderBaseSql : public virtual EncoderBase
 {
	WOSH_CLASSNAME(wosh::persistence::EncoderBaseSql)
	WOSH_CLASS_ABSTRACT(true)

	public:
		virtual ~EncoderBaseSql() { }

}; // class def


 }; // namespace persistence
}; // namespace wosh

#endif //__WOSH_Persistence_EncoderProtocolSql_H__
