/** @file    EncoderProtocolXml.cpp
 *  @author  Alessandro Polo
 *  @version $Id: EncoderProtocolXml.cpp 2601 2010-05-29 01:51:40Z alex $
 *  @brief
 * File containing methods for the wosh::persistence::EncoderProtocolXml class.
 * The header for this class can be found in EncoderProtocolXml.h, check that file
 * for class description.
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/
 
 #include <framework/persistence/EncoderProtocolXml.h>

 #include <core/ObjectAllocator.h>

namespace wosh {
 namespace persistence {

 WOSH_REGISTER_INTERFACE(wosh::persistence::PersistenceDbXml, "wosh::PersistenceDb", 1.01, _static_PersistenceDbXml )
 WOSH_REGISTER_INTERFACE(wosh::persistence::EncoderBaseXml, "wosh::EncoderBase", 1.00, _static_EncoderBaseXml )

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
 
 WOSH_REGISTER_INTERFACE(wosh::persistence::EncoderProtocolXml, "wosh::EncoderProtocol", 1.01, _static_EncoderProtocolXml )

EncoderProtocolXml::EncoderProtocolXml()
	: EncoderProtocol() {
	Object::setName("EncoderProtocolXml", Utilities::randomLong() );
 }

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

 }; // namespace persistence
}; // namespace wosh
