/** @file    EncodersXmlL2_Core.cpp
 *  @author  Alessandro Polo
 *  @version $Id: EncodersXmlL2_Core.cpp 2542 2010-05-26 00:48:23Z alex $
 *  @brief
 * The header for this class can be found in EncodersXmlL2_Core.h, check that file
 * for class description.
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/
 
 #include <framework/persistence/libxml2/EncodersXmlL2_Core.h>

 #include <core/ObjectAllocator.h>


namespace wosh {
 namespace persistence {
  namespace libxml2 {


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

 WOSH_ENCODER_XML_L2_BIND(wosh::persistence::libxml2::EncoderXml_libxml2_Variant, "wosh::Variant", 0.0, _static_EncoderXml_libxml2_Variant )

WRESULT EncoderXml_libxml2_Variant::serializeTo( const wosh::Variant* object, xmlDocPtr doc, xmlNsPtr ns, xmlNodePtr contNode, int encoder_options ) {
	if ( object == NULL ) return WRET_ERR_PARAM;
	EncoderBaseXmlL2::serializeString( "type", object->getTypeAsString(), contNode, encoder_options );
	EncoderBaseXmlL2::serializeString( "data", object->toString(), contNode, encoder_options );
	return WRET_OK;
 }

WRESULT EncoderXml_libxml2_Variant::deserializeFrom( wosh::Variant* object, xmlDocPtr doc, xmlNsPtr ns, xmlNodePtr contNode ) {
	if ( object == NULL ) return WRET_ERR_PARAM;

	object->clear();
	return WRET_OK;

	return WRET_OK;
 }

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

  }; // namespace libxml2
 }; // namespace persistence
}; // namespace wosh
