/**
 * @file   EncodersXmlL2_Core.h
 * @brief   
 *
 ****************************************************************************
 * @version $Id: EncodersXmlL2_Core.h 2536 2010-05-24 17:41:58Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Persistence_libxml2_EncodersXmlL2_Core_H__
 #define __WOSH_Persistence_libxml2_EncodersXmlL2_Core_H__

 #include <framework/persistence/libxml2/EncoderProtocolXmlL2.h>


 #include <core/Communicator.h>
 #include <core/Fact.h>
 #include <core/Message.h>
 #include <core/MessageNetworkForwarding.h>
 #include <core/List.h>
 #include <core/Notification.h>
 #include <core/Object.h>
 #include <core/ObjectAllocator.h>
 #include <core/Permission.h>
 #include <core/Property.h>
 #include <core/PropertiesProvider.h>
 #include <core/Request.h>
 #include <core/Response.h>
 #include <core/SecurityToken.h>
 #include <core/SystemError.h>
 #include <core/Table.h>
 #include <core/Tree.h>
 #include <core/URI.h>
 #include <core/User.h>
 #include <core/Variant.h>
 #include <core/WoshHost.h>


namespace wosh {
 namespace persistence {
  namespace libxml2 {


WOSH_ENCODER_XML_L2_CLASS(EncoderXml_libxml2_Variant, wosh::Variant)

//WOSH_ENCODER_XML_L2_CLASS(EncoderXml_libxml2_WoshHost, wosh::WoshHost)



  }; // namespace libxml2
 }; // namespace persistence
}; // namespace wosh

#endif //__WOSH_Persistence_libxml2_EncodersXmlL2_Core_H__
