/**
 * @file   EncodersPlainText_Core.h
 * @brief   
 *
 ****************************************************************************
 * @version $Id: EncodersPlainText_Core.h 2686 2010-06-21 11:27:32Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Persistence_PlainText_EncodersPlainText_Core_H__
 #define __WOSH_Persistence_PlainText_EncodersPlainText_Core_H__

 #include <framework/persistence/plaintext/EncoderProtocolPlainText.h>

 #include <core/List.h>
 #include <core/Notification.h>
 #include <core/Object.h>
 #include <core/ObjectAllocator.h>
 #include <core/Property.h>
 #include <core/SharedMemory.h>
 #include <core/SystemError.h>
 #include <core/Table.h>
 #include <core/Tree.h>
 #include <core/Variant.h>
 #include <core/WoshHost.h>


namespace wosh {
 namespace persistence {
  namespace plaintext {

WOSH_ENCODER_PlainText_CLASS(EncoderPlainText_List, wosh::List)

WOSH_ENCODER_PlainText_CLASS(EncoderPlainText_Notification, wosh::Notification)

WOSH_ENCODER_PlainText_CLASS(EncoderPlainText_Object, wosh::Object)

WOSH_ENCODER_PlainText_CLASS(EncoderPlainText_ObjectTypeInfo, wosh::ObjectTypeInfo)

WOSH_ENCODER_PlainText_CLASS(EncoderPlainText_Property, wosh::Property)

WOSH_ENCODER_PlainText_CLASS(EncoderPlainText_SharedMemoryInfo, wosh::SharedMemoryInfo)

WOSH_ENCODER_PlainText_CLASS(EncoderPlainText_SystemError, wosh::SystemError)

WOSH_ENCODER_PlainText_CLASS(EncoderPlainText_Table, wosh::Table)

WOSH_ENCODER_PlainText_CLASS(EncoderPlainText_Tree, wosh::Tree)

WOSH_ENCODER_PlainText_CLASS(EncoderPlainText_TreeNode, wosh::TreeNode)

//WOSH_ENCODER_PlainText_CLASS(EncoderPlainText_Variant, wosh::Variant)

WOSH_ENCODER_PlainText_CLASS(EncoderPlainText_WoshHost, wosh::WoshHost)


 }; // namespace plaintext
 }; // namespace persistence
}; // namespace wosh

#endif //__WOSH_Persistence_PlainText_EncodersPlainText_Core_H__
