/**
 * @file   EncodersXmlQt_Core.h
 * @brief   
 *
 ****************************************************************************
 * @version $Id: EncodersXmlQt_Core.h 2686 2010-06-21 11:27:32Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Persistence_Qt_EncodersXmlQt_Core_H__
 #define __WOSH_Persistence_Qt_EncodersXmlQt_Core_H__

 #include <framework/persistence/qt/EncoderProtocolXmlQt.h>


 #include <core/Communicator.h>
 #include <core/Fact.h>
 #include <core/Message.h>
 #include <core/MessageNetworkForwarding.h>
 #include <core/List.h>
 #include <core/Notification.h>
 #include <core/Object.h>
 #include <core/ObjectAllocator.h>
 #include <core/Permission.h>
 #include <core/Property.h>
 #include <core/PropertiesProvider.h>
 #include <core/Request.h>
 #include <core/Response.h>
 #include <core/ResourcePath.h>
 #include <core/SecurityToken.h>
 #include <core/SharedMemory.h>
 #include <core/SystemError.h>
 #include <core/Table.h>
 #include <core/Tree.h>
 #include <core/URI.h>
 #include <core/User.h>
 #include <core/Variant.h>
 #include <core/WoshHost.h>


namespace wosh {
 namespace persistence {
  namespace qt {


WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_Communicator, wosh::Communicator)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_Fact, wosh::Fact)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_Message, wosh::Message)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_MessageNetworkForwarding, wosh::MessageNetworkForwarding)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_List, wosh::List)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_Notification, wosh::Notification)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_Object, wosh::Object)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_ObjectTypeInfo, wosh::ObjectTypeInfo)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_Permission, wosh::Permission)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_Property, wosh::Property)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_PropertiesProvider, wosh::PropertiesProvider)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_Request, wosh::Request)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_Response, wosh::Response)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_ResourcePath, wosh::ResourcePath)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_SecurityToken, wosh::SecurityToken)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_SharedMemoryInfo, wosh::SharedMemoryInfo)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_SystemError, wosh::SystemError)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_Table, wosh::Table)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_Tree, wosh::Tree)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_TreeNode, wosh::TreeNode)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_URI, wosh::URI)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_User, wosh::User)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_Variant, wosh::Variant)

WOSH_ENCODER_XML_Qt_CLASS(EncoderXml_Qt_WoshHost, wosh::WoshHost)



  }; // namespace qt
 }; // namespace persistence
}; // namespace wosh

#endif //__WOSH_Persistence_Qt_EncodersXmlQt_Core_H__
