/**
 * @file    framework/security.h
 * @brief   Include all components of the security framework
 ****************************************************************************
 * @version 0.00 $Id: security.h 2290 2010-04-09 11:31:59Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/*! @namespace wosh::security
 * @brief   Contains classes regarding security and safety of the home and the system itself.
 * @see     Refer to wosh::SecurityToken object and wosh::SecurityManager core-module.
 * @see     \ref page_framework_security
 *
 ****************************************************************************/
/*! \page page_framework
 * \htmlonly <hr/> \endhtmlonly
 * \section page_framework_security WOSH Security Framework
 *
 * \warning Security and safety of (and provided by) the WOSH system are still under planning.
 *
 * \todo [..]
 *
 * Many classes are part of the Alarm system, implemented by wosh::services::AlarmBundle.
 *
 * @see     wosh::security
 * @see     wosh::services::AlarmBundle
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_FrameWork_Security_H__
 #define __WOSH_FrameWork_Security_H__

 #include <woshDefs.h>

namespace wosh {
 namespace security { };
 };

 #include <framework/security/AlarmTrigger.h>


#endif //__WOSH_FrameWork_Security_H__
