/** @file    SecurityAuthenticationProxy.cpp
 *  @author  Alessandro Polo
 *  @version $Id: SecurityAuthenticationProxy.cpp 2561 2010-05-27 03:30:39Z alex $
 *  @brief
 * File containing methods for the wosh::security::SecurityAuthenticationProxy class.
 * The header for this class can be found in SecurityAuthenticationProxy.h, check that file
 * for class description.
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

 #include <framework/security/SecurityAuthenticationProxy.h>

 #include <core/UserManager.h>
// #include <core/User.h>
 #include <core/ObjectAllocator.h>

using namespace std;
namespace wosh {
 namespace security {

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

 WOSH_REGISTER(wosh::security::SecurityTokenProxy, "wosh::SecurityToken", _SecurityTokenProxy_VERSION, _static_SecurityTokenProxy)

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

 WOSH_REGISTER(wosh::security::SecurityTokenProviderProxy, "wosh::SecurityTokenProvider", _SecurityTokenProxy_VERSION, _static_SecurityTokenProviderProxy)

SecurityTokenProviderProxy::SecurityTokenProviderProxy()
	: SecurityTokenProvider() {
 }
SecurityTokenProviderProxy::SecurityTokenProviderProxy( const SecurityTokenProviderProxy& m )
	: SecurityTokenProvider(m) {
 }


SecurityToken* SecurityTokenProviderProxy::createToken() const {
	SecurityTokenProxy* st = new SecurityTokenProxy();
//	st->data = this->data;
	return st;
 }

SecurityTokenProxy* SecurityTokenProviderProxy::createToken( const std::string& account_name ) const {
	SecurityTokenProxy* st = new SecurityTokenProxy();
//	st->data = this->data;
	return st;
 }

SecurityToken* SecurityTokenProviderProxy::signMessage( Message* message, const std::string& username, const std::string& account_name ) const {
	SecurityTokenProxy* st = createToken(account_name);
	initToken(st);
	setupToken(st, username);
	finalizeSigning(st, message);
	return st;
 }

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

 WOSH_REGISTER(wosh::security::SecurityTokenAuthenticatorProxy, "wosh::SecurityTokenAuthenticator", _SecurityTokenProxy_VERSION, _static_SecurityTokenAuthenticatorProxy)

SecurityTokenAuthenticatorProxy::SecurityTokenAuthenticatorProxy()
	: SecurityTokenAuthenticator() {
 }
SecurityTokenAuthenticatorProxy::SecurityTokenAuthenticatorProxy( const SecurityTokenAuthenticatorProxy& m )
	: SecurityTokenAuthenticator(m) {
 }

bool SecurityTokenAuthenticatorProxy::isSupported( const char* provider_classname, double version ) const {
	if ( provider_classname == NULL ) return false;
	if ( strcmp(provider_classname, SecurityTokenProxy::className()) != 0 ) return false;
	if ( version != 0.0 && version > _SecurityTokenProxy_VERSION ) return false;
	return true;
 }

WRESULT SecurityTokenAuthenticatorProxy::validateToken( const SecurityToken* token ) const {






	return WRET_ERR_INTERNAL;
 }

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////


 

































/*

 //WOSH_REGISTER_INTERFACE(wosh::security::SecurityAuthenticationProxy, "wosh::SecurityAuthentication", 1.0, _static_SecurityAuthenticationProxy )
 WOSH_REGISTER(wosh::security::SecurityAuthenticationProxy, "wosh::SecurityAuthentication", 1.0, _static_SecurityAuthenticationProxy )

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////// CONSTRUCTORS

SecurityAuthenticationProxy::SecurityAuthenticationProxy()
	: SecurityAuthentication() {
	this->provider_name = "";
 }

SecurityAuthenticationProxy::SecurityAuthenticationProxy( const SecurityAuthenticationProxy& m )
	: SecurityAuthentication(m) {
	this->provider_name = m.provider_name;
 }

//////////////////////////////////////////////////////////////////////////////////////////////// CONSTRUCTORS
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

SecurityToken* SecurityAuthenticationProxy::generateToken( const Object* object ) {
	if ( object == NULL ) return NULL;
	SecurityToken* st = NULL;

	return st;
 }

SecurityToken* SecurityAuthenticationProxy::generateToken( const std::string& user, const Object* object ) {
	SecurityToken* st = NULL;

	return st;
 }

WRESULT SecurityAuthenticationProxy::validateToken( const SecurityToken* token, const Object* object ) {
	if ( token == NULL ) return WRET_ERR_PARAM;
	if ( object == NULL ) return WRET_ERR_PARAM;

	return WRET_ERR_INTERNAL;
 }

WRESULT SecurityAuthenticationProxy::validateToken( const SecurityToken* token, const std::string& user, const Object* object ) {
	if ( token == NULL ) return WRET_ERR_PARAM;

	return WRET_ERR_INTERNAL;
 }

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

WRESULT SecurityAuthenticationProxy::validate( const wosh::User* user ) const {
	return WRET_OK;
 }
*/
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

 }; // namespace security
}; // namespace wosh
