/**
 * @class   wosh::interfaces::devices::Dimmer
 * @brief   Standard interface of a generic Dimmer (device).
 *          A Dimmer is a particular switch.
 *
 * @ingroup Interfaces
 ****************************************************************************
 * @version 0.8.384 $Id: Dimmer.h 2282 2010-04-07 06:20:24Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Interfaces_Devices_Dimmer_H__
 #define __WOSH_Interfaces_Devices_Dimmer_H__

 #include <interfaces/devices/Switch.h>


namespace wosh {
 namespace interfaces {
  namespace devices {

 #define _Dimmer_INTERFACE				"wosh::devices::Dimmer"

 #define _Dimmer_KEY_Status				"Status"

 #define _Dimmer_METHOD_set				"set"
 #define _Dimmer_METHOD_dim				"dim"
 #define _Dimmer_METHOD_bright			"bright"

 #define _Device_Type_Dimmer			"Dimmer"

class Dimmer : public virtual Switch
 {
	WOSH_BUNDLE_INTERFACE("wosh::interfaces::devices::Dimmer")


	public:
		virtual ~Dimmer() { }

}; // class def

  }; // namespace devices
 }; // namespace interfaces
}; // namespace wosh

#endif //__WOSH_Interfaces_Devices_Dimmer_H__
