/**
 * @class   wosh::interfaces::devices::Phone
 * @brief   Standard interface of generic phone (device).
 *
 * @see     wosh::devices::WindowsMobileBundle
 * @ingroup Interfaces
 ****************************************************************************
 * @version 0.8.384 $Id: Phone.h 2282 2010-04-07 06:20:24Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Interfaces_Devices_Phone_H__
 #define __WOSH_Interfaces_Devices_Phone_H__

 #include <interfaces/Device.h>


namespace wosh {
 namespace interfaces {
  namespace devices {
  
 #define _Phone_TYPE					"wosh::interfaces::devices::Phone"

 #define _Phone_KEY_PhoneNumber			"PhoneNumber"
 #define _Phone_KEY_PhoneLinesNumber	"PhoneLinesNumber"
 #define _Phone_KEY_PhoneUser			"PhoneUser"


 #define _Phone_METHOD_dial				"dial"
 #define _Phone_METHOD_hangup			"hangup"
 #define _Phone_METHOD_answer			"answer"

 #define _Phone_EVENT_call_idle			"call_idle"
 #define _Phone_EVENT_call_incoming		"call_incoming"


class Phone : public virtual Device
 {
	WOSH_BUNDLE_INTERFACE("wosh::interfaces::devices::Phone")


	public:
		virtual ~Phone() { }

}; // class def

  }; // namespace devices
 }; // namespace interfaces
}; // namespace wosh

#endif //__WOSH_Interfaces_Devices_Phone_H__
