/**
 * @class   wosh::interfaces::services::BuildingManager
 * @brief   Standard interface of Building Manager (service).
 *
 * @ingroup Interfaces
 ****************************************************************************
 * @version 0.8.384 $Id: BuildingManager.h 2781 2010-07-19 23:15:58Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Interfaces_Services_BuildingManager_H__
 #define __WOSH_Interfaces_Services_BuildingManager_H__

 #include <interfaces/Service.h>


namespace wosh {
 namespace interfaces {
  namespace services {

 #define _BuildingManager_NAME					"BuildingManager"
 #define _BuildingManager_TYPE					"wosh::services::BuildingManager"

 #define _BuildingManager_KEY_count				"count"

 #define _BuildingManager_KEY_DB				"DataBaseFile"
 #define _BuildingManager_KEY_DB_shadow			"DataBaseShadowFile"

 #define _BuildingManager_METHOD_tree			"tree"
 #define _BuildingManager_METHOD_load			"load"
 #define _BuildingManager_METHOD_save			"save"
 #define _BuildingManager_METHOD_reload			"reload"
 #define _BuildingManager_METHOD_fake_event		"fake_event"
 #define _BuildingManager_METHOD_getchildprop	"getchildprop"

 #define _BuildingManager_EVENT_ObjectUpdated	"ObjectUpdated"


class BuildingManager : public virtual Service
 {
	WOSH_BUNDLE_INTERFACE("wosh::interfaces::services::BuildingManager")


	public:
		virtual ~BuildingManager() { }

  }; // namespace services
 }; // namespace interfaces
}; // class def

}; // namespace wosh

#endif //__WOSH_Interfaces_Services_BuildingManager_H__
