/**
 * @class   wosh::interfaces::services::CommunicationManager
 * @brief   Standard interface of Communication Manager (service).
 *
 * @ingroup Interfaces
 ****************************************************************************
 * @version 0.8.384 $Id: CommunicationManager.h 2524 2010-05-22 06:05:19Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Interfaces_Services_CommunicationManager_H__
 #define __WOSH_Interfaces_Services_CommunicationManager_H__

 #include <interfaces/Service.h>


namespace wosh {
 namespace interfaces {
  namespace services {

 #define _CommunicationManager_NAME						"CommunicationManager"
 #define _CommunicationManager_TYPE						"wosh::services::CommunicationManager"

 #define _CommunicationManager_KEY_count				"count"

 #define _CommunicationManager_KEY_ServiceTimeOut		"ServiceTimeOut"
 #define _CommunicationManager_KEY_FlowTimeOut			"FlowTimeOut"
 #define _CommunicationManager_KEY_FlowRetryTime		"FlowRetryTime"


 #define _CommunicationManager_METHOD_messages			"messages"
 #define _CommunicationManager_METHOD_messages_dump		"messages_dump"

 #define _CommunicationManager_METHOD_messages_archived	"messages_archived"
 #define _CommunicationManager_METHOD_messages_my		"messages_my"

 #define _CommunicationManager_METHOD_mark				"mark"

 #define _CommunicationManager_METHOD_communicators		"communicators"
 #define _CommunicationManager_METHOD_interpreters		"interpreters"


 #define _CommunicationManager_METHOD_fake_event		"fake_event"

 #define _CommunicationManager_METHOD_update_comm		"update_comm"
 #define _CommunicationManager_METHOD_update_inter		"update_inter"


class CommunicationManager : public virtual Service
 {
	WOSH_BUNDLE_INTERFACE("wosh::interfaces::services::CommunicationManager")


	public:
		virtual ~CommunicationManager() { }

}; // class def

  }; // namespace services
 }; // namespace interfaces
}; // namespace wosh

#endif //__WOSH_Interfaces_Services_CommunicationManager_H__
