/**
 * @class   wosh::interfaces::services::MediaDirector
 * @brief   Standard interface of MediaDirector (service).
 *
 * @ingroup Interfaces
 ****************************************************************************
 * @version 0.8.384 $Id: MediaDirector.h 2282 2010-04-07 06:20:24Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Interfaces_Services_MediaDirector_H__
 #define __WOSH_Interfaces_Services_MediaDirector_H__

 #include <interfaces/Service.h>


namespace wosh {
 namespace interfaces {
  namespace services {

 #define _MediaDirector_NAME					"MediaDirector"
 #define _MediaDirector_TYPE					"wosh::services::MediaDirector"

 #define _MediaDirector_KEY_count				"count"

 #define _MediaDirector_KEY_MediaZoneDB			"MediaZoneDB"
 #define _MediaDirector_KEY_MediaZoneDB_shadow	"MediaZoneDB_shadow"
 #define _MediaDirector_KEY_MediaListDB			"MediaListDB"
 #define _MediaDirector_KEY_MediaListDB_shadow	"MediaListDB_shadow"

 #define _MediaDirector_KEY_DB					"DataBaseFile"
 #define _MediaDirector_KEY_DB_shadow			"DataBaseShadowFile"

 #define _MediaDirector_KEY_MediaTrackDB		"MediaTrackDB"

 #define _MediaDirector_KEY_MediaDB				"MediaDB"

 #define _MediaDirector_METHOD_list_playlists	"list_playlists"
 #define _MediaDirector_METHOD_get_matrix		"getmatrix"
 
 #define _MediaDirector_METHOD_get_playlist		"get_playlist"

 #define _MediaDirector_METHOD_list_join 		"list_join"

 #define _MediaDirector_METHOD_play				"play"
 #define _MediaDirector_METHOD_stop				"stop"


 #define _MediaDirector_METHOD_load				"load"
 #define _MediaDirector_METHOD_save				"save"

 #define _MediaDirector_METHOD_forceupdate		"update"



class MediaDirector : public virtual Service
 {
	WOSH_BUNDLE_INTERFACE("wosh::interfaces::services::MediaDirector")


	public:
		virtual ~MediaDirector() { }

}; // class def

  }; // namespace services
 }; // namespace interfaces
}; // namespace wosh

#endif //__WOSH_Interfaces_Services_MediaDirector_H__
