/**
 * @class   wosh::interfaces::services::TelnetServer
 * @brief   Standard interface of Telnet Server (service).
 *
 * @ingroup Interfaces
 ****************************************************************************
 * @version 0.8.384 $Id: TelnetServer.h 2282 2010-04-07 06:20:24Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Interfaces_Services_TelnetServer_H__
 #define __WOSH_Interfaces_Services_TelnetServer_H__

 #include <interfaces/Service.h>


namespace wosh {

 namespace security {
  class Session;
 };

 namespace interfaces {
  namespace services {

 #define _TelnetServer_NAME						"TelnetServer"
 #define _TelnetServer_TYPE						"wosh::services::TelnetServer"

 #define _TelnetServer_KEY_WelcomeString		"WelcomeString"
 #define _TelnetServer_KEY_BindAddressPort		"BindAddressPort"

 #define _TelnetServer_KEY_MaxConnections		"MaxConnections"
 #define _TelnetServer_KEY_MaxRetries			"MaxRetries"
 #define _TelnetServer_KEY_PingTimeout			"PingTimeout"

 #define _TelnetServer_KEY_GreenList			"GreenList"
 #define _TelnetServer_KEY_YellowList			"YellowList"
 #define _TelnetServer_KEY_BlackList			"BlackList"

 #define _TelnetServer_KEY_GrantRootAccess		"GrantRootAccess"
 #define _TelnetServer_KEY_GrantSudo			"GrantSudo"
 #define _TelnetServer_KEY_		""

 #define _TelnetServer_KEY_		""
 #define _TelnetServer_KEY_		""
 #define _TelnetServer_KEY_		""


class TelnetServer : public virtual Service
 {
	WOSH_BUNDLE_INTERFACE("wosh::interfaces::services::TelnetServer")


	public:
		virtual ~TelnetServer() { }

}; // class def

  }; // namespace services
 }; // namespace interfaces
}; // namespace wosh

#endif //__WOSH_Interfaces_Services_TelnetServer_H__
