/**
 * @class   wosh::interfaces::services::Weather
 * @brief   Standard interface of Weather (service).
 *
 * @ingroup Interfaces
 ****************************************************************************
 * @version 0.8.384 $Id: Weather.h 2804 2010-07-27 04:39:07Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Interfaces_Services_Weather_H__
 #define __WOSH_Interfaces_Services_Weather_H__

 #include <interfaces/Service.h>


namespace wosh {
 namespace interfaces {
  namespace services {

 #define _Weather_NAME								"Weather"
 #define _Weather_TYPE								"wosh::services::Weather"


 #define _Weather_METHOD_get_weather				"get_weather"
 #define _Weather_METHOD_get_forecast				"get_forecast"
 #define _Weather_METHOD_get_forecast_tbl			"get_forecast_tbl"

 #define _Weather_METHOD_export						"export"

 #define _Weather_KEY_CurrentCondition				"CurrentCondition"

 #define _Weather_KEY_CurrentWeatherTs				"CurrentWeatherTs"
 #define _Weather_KEY_ForeCastTs					"ForeCastTs"

 #define _Weather_KEY_WeatherSourceCount			"WeatherSourceCount"

 #define _Weather_KEY_WeatherSimilarityThreshold	"WeatherSimilarityThreshold"

 /*
 #define _Weather_KEY_Longitude				"Longitude"
 #define _Weather_KEY_TimeZone				"TimeZone"

 #define _Weather_KEY_RaiseEventSunRise		"RaiseEventSunRise"
 #define _Weather_KEY_RaiseEventSunSet		"RaiseEventSunSet"
 #define _Weather_KEY_SunStatsTs			"SunStatsTs"
 #define _Weather_KEY_MoonStatsTs			"MoonStatsTs"

 #define _Weather_KEY_SunRise				"SunRise"
 #define _Weather_KEY_SunSet				"SunSet"
 #define _Weather_KEY_CivilTwilightAM		"CivilTwilightAM"
 #define _Weather_KEY_CivilTwilightPM		"CivilTwilightPM"
 #define _Weather_KEY_DayLength				"DayLength"
 #define _Weather_KEY_AltitudeNoonTime		"AltitudeNoonTime"
 #define _Weather_KEY_AltitudeNoonDegree	"AltitudeNoonDegree"
 #define _Weather_KEY_Declination			"Declination"

 #define _Weather_KEY_MoonPrevNew			"MoonPrevNew"
 #define _Weather_KEY_MoonPrevFull			"MoonPrevFull"
 #define _Weather_KEY_MoonNextNew			"MoonNextNew"
 #define _Weather_KEY_MoonNextFull			"MoonNextFull"

 #define _Weather_METHOD_load				"load"
 #define _Weather_METHOD_update				"update"
 #define _Weather_METHOD_update_sun			"update_sun"
 #define _Weather_METHOD_update_moon		"update_moon"
*/
 

class Weather : public virtual Service
 {
	WOSH_BUNDLE_INTERFACE("wosh::interfaces::services::Weather")


	public:
		virtual ~Weather() { }

}; // class def

  }; // namespace services
 }; // namespace interfaces
}; // namespace wosh

#endif //__WOSH_Interfaces_Services_Weather_H__
