# QMAKE Configuration file
# Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
# by Alessandro Polo - OpenSmartHome.com
# All rights reserved.
#######################################################
# Revision $Id: woshremote.pro 2274 2010-04-06 01:40:21Z alex $
#######################################################

message( "WOSH Remote (multi-platform)" )

#####################################################
# generic configuration options
# woshremote is a styled-gui application
#
TEMPLATE = app
TARGET = woshremote

#####################################################
# set namespaces of the WOSH Framework to build-in
#
CONFIG += WOSH_AUTOMATIONS
CONFIG += WOSH_BUILDING
CONFIG += WOSH_COMMUNICATION
CONFIG += WOSH_ENTERTAINMENT
CONFIG += WOSH_GUI
CONFIG += WOSH_PLUGINS
CONFIG += WOSH_SECURITY
CONFIG += WOSH_XTENDED


#####################################################
# include core and interfaces, see
# framework/framework.pro for options, many
# namespaces are disabled by default
#
!include( common.pri ) {
	error( "FATAL: Project file 'common.pri' is missing! (misaligned distribution?)" )
}
#####################################################
# include WOSH Framework, framework options must be
# configured before following command.
#
!include( framework/framework.pro ) {
	error( "FATAL: Project file 'framework/framework.pro' is missing! (misaligned distribution?)" )
}
#####################################################
# force inclusion of DiscoveryUdp service
#
!include( bundles/services/DiscoveryUdp/DiscoveryUdp.prf ) {
	message( "*****  No bundles/services/DiscoveryUdp/DiscoveryUdp.prf file found. SKIPPED. *****" )
}
#####################################################
# force inclusion of Desktop-Notifier service
#
!include( bundles/services/DesktopNotifier/DesktopNotifier.prf ) {
	message( "*****  No bundles/services/DesktopNotifier/DesktopNotifier.prf file found. SKIPPED. *****" )
}

#####################################################
# define application's resources
#
RESOURCES += apps/woshremote/woshremote.qrc
RESOURCES += apps/woshremote/woshremote_styles.qrc

TRANSLATIONS += apps/woshremote/translations/woshremote_it.ts

#####################################################
# include application's core file
#
SOURCES += apps/woshremote/woshremote.cpp

HEADERS += apps/woshremote/WoshRemoteWindow.h
SOURCES += apps/woshremote/WoshRemoteWindow.cpp
FORMS   += apps/woshremote/WoshRemoteWindow.ui


