# QMAKE Configuration file
# Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
# by Alessandro Polo - OpenSmartHome.com
# All rights reserved.
#######################################################
# Revision $Id: woshshop.pro 2349 2010-04-24 11:41:47Z alex $
#######################################################

message( "WOSH WorkShop (multi-platform)" )

#####################################################
# generic configuration options
# woshshop is a styled-gui application
#
TEMPLATE = app
TARGET = woshshop

#####################################################
# set namespaces of the WOSH Framework to build-in
#
#CONFIG += WOSH_AI
CONFIG += WOSH_AUTOMATIONS
CONFIG += WOSH_BUILDING
CONFIG += WOSH_COMMUNICATION
CONFIG += WOSH_ENTERTAINMENT
CONFIG += WOSH_GUI
CONFIG += WOSH_PLUGINS
CONFIG += WOSH_SECURITY
CONFIG += WOSH_XTENDED

CONFIG += WOSH_KIOSK
CONFIG += DB_SQL


#####################################################
# include core and interfaces, see
# framework/framework.pro for options, many
# namespaces are disabled by default
#
!include( common.pri ) {
	error( "FATAL: Project file 'common.pri' is missing! (misaligned distribution?)" )
}
#####################################################
# include WOSH Framework, framework options must be
# configured before following command.
#
!include( framework/framework.pro ) {
	error( "FATAL: Project file 'framework/framework.pro' is missing! (misaligned distribution?)" )
}
#####################################################
# include bundles, to include/exclude a bundle, 
# customize project files bundles\devices\devices.pri
# and bundles\services\services.pri
#
!include( bundles/bundles.pro ) {
	error( "FATAL: Project file 'bundles/bundles.pro' is missing! (misaligned distribution?)" )
} 

#####################################################
# define application's resources
#
RESOURCES += apps/woshshop/woshshop.qrc

TRANSLATIONS += apps/woshshop/translations/woshshop_it.ts

#####################################################
# include application's core file
#
SOURCES += apps/woshshop/woshshop.cpp

HEADERS += apps/woshshop/WoshShopWindow.h
SOURCES += apps/woshshop/WoshShopWindow.cpp
FORMS   += apps/woshshop/WoshShopWindow.ui

HEADERS += apps/woshshop/FormScreenshoter.h
SOURCES += apps/woshshop/FormScreenshoter.cpp
FORMS   += apps/woshshop/FormScreenshoter.ui

HEADERS += apps/woshshop/FormConfiguration.h
SOURCES += apps/woshshop/FormConfiguration.cpp

HEADERS += apps/woshshop/FormConfigurationPage.h
HEADERS += apps/woshshop/FormConfigurationPages.h
SOURCES += apps/woshshop/FormConfigurationPages.cpp


