<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="xml" encoding="utf-8" indent="yes" />


<xsl:template match="/">
  <xsl:apply-templates />
</xsl:template>

<xsl:template match="Bundle">

<html> 
  <head>
    <title>WOSH Bundle: <xsl:value-of select="@name"/></title>
  </head>
  <body>
    <p>Language: <xsl:value-of select="/Documentation/@language"/><p>
    <hr/>

    <xsl:apply-templates select="Properties" />

    <hr/>

    <xsl:apply-templates select="Methods" />


  </body>
</html>

</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->
<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->

<xsl:template match="Properties">
  <div id="properties">
    <h3><a name="properties">Properties</a></h3>
    <xsl:apply-templates select="Property" />
  </div>
</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->

<xsl:template match="Methods">
  <div id="methods">
    <h3><a name="methods">Methods</a></h3>
    <xsl:apply-templates select="Method" />
  </div>
</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->

<xsl:template match="Property">
  <div class="property" id="property_{@name}">
    <div class="property_title">
      <xsl:value-of select="@name"/>
    </div>
    <xsl:apply-templates select="datatype" />
    <xsl:apply-templates select="readonly" />
    <xsl:apply-templates select="description" />
    <xsl:apply-templates select="keywords" />
    <xsl:apply-templates select="see" />
  </div>
</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->

<xsl:template match="Method">
  <div class="method" id="method_{@name}">
    <div class="method_title">
      <xsl:value-of select="@name"/>
    </div>
    <xsl:apply-templates select="synopsis" />
    <xsl:apply-templates select="description" />
    <xsl:apply-templates select="keywords" />
    <xsl:apply-templates select="see" />
  </div>
</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->

<xsl:template match="datatype">
  <div class="datatype">
    <xsl:value-of select="datatype"/>
  </div>
</xsl:template>

<xsl:template match="readonly">
  <div class="readonly">
    <xsl:value-of select="readonly"/>
  </div>
</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->

<xsl:template match="synopsis">
  <div class="synopsis">
    <xsl:value-of select="synopsis"/>
  </div>
</xsl:template>

<xsl:template match="description">
  <div class="description">
    <xsl:value-of select="description"/>
  </div>
</xsl:template>

<xsl:template match="keywords">
  <div class="keywords">
    <xsl:value-of select="keywords"/>
  </div>
</xsl:template>

<xsl:template match="see">
  <div class="see_ref">
    <xsl:value-of select="see"/>
  </div>
</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->





</xsl:stylesheet>
