<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="xml" encoding="utf-8" indent="yes" />


<xsl:template match="/">
  <xsl:apply-templates />
</xsl:template>

<xsl:template match="Bundle">

<html> 
  <head>
    <title>WOSH Bundle: <xsl:value-of select="@name"/></title>
  </head>
  <body>
    <hr/>
    <h3><a name="properties">Properties</a></h3>
    <xsl:apply-templates select="Properties" />

    <hr/>
    <h3><a name="methods">Methods</a></h3>
    <xsl:apply-templates select="Methods" />


  </body>
</html>

</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->
<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->

<xsl:template match="Properties">
  <xsl:apply-templates select="Property" />
</xsl:template>

<xsl:template match="Property">
  <p><xsl:value-of select="@name"/></p>
  <p><xsl:value-of select="description"/></p>

</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->
<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->

<xsl:template match="Methods">
  <xsl:apply-templates select="Method" />
</xsl:template>

<xsl:template match="Method">
  <p><xsl:value-of select="@name"/></p>
  <p><xsl:value-of select="description"/></p>

</xsl:template>


</xsl:stylesheet>
